diff --git a/util/nbt/src/main/java/com/mojang/nbt/NbtIo.java b/util/nbt/src/main/java/com/mojang/nbt/NbtIo.java
index c4b20110e..10c6461ad 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/NbtIo.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/NbtIo.java
@@ -1,17 +1,32 @@
 package com.mojang.nbt;
 
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.Tag;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
+import java.util.Map;
 import java.util.zip.GZIPInputStream;
 import java.util.zip.GZIPOutputStream;
 
 public class NbtIo
 {
+    public static @NotNull CompoundTag fromJson(@NotNull JsonElement element) throws JsonParseException {
+        if (!element.isJsonObject()) throw new JsonParseException("Root NBT Json element must be a JsonObject!");
+        final CompoundTag compoundTag = new CompoundTag();
+        compoundTag.fromJson(element);
+        return compoundTag;
+    }
+
+    public static @NotNull JsonElement toJson(@NotNull CompoundTag tag) {
+        return tag.toJson();
+    }
+
     @SuppressWarnings("unused")
-    public static CompoundTag readCompressed(InputStream inputStream)
+    public static @NotNull CompoundTag readCompressed(InputStream inputStream)
         throws IOException
     {
         try (DataInputStream datainputstream = new DataInputStream(new GZIPInputStream(inputStream)))
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/ByteArrayTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/ByteArrayTag.java
index b399301c5..2bb14a00f 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/ByteArrayTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/ByteArrayTag.java
@@ -1,5 +1,9 @@
 package com.mojang.nbt.tags;
 
+import com.google.gson.JsonArray;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonPrimitive;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
@@ -26,6 +30,32 @@ public class ByteArrayTag extends Tag<byte @NotNull []>
         dos.write(getValue());
     }
 
+    @Override
+    public void fromJson(@NotNull final JsonElement element) throws JsonParseException {
+        if (!element.isJsonArray()) throw new JsonParseException("ByteArrayTag json value must be a json array!");
+        final JsonArray array = element.getAsJsonArray();
+        final byte[] bytes = new byte[array.size()];
+        for (int i = 0; i < bytes.length; i++) {
+            final JsonElement e = array.get(i);
+            if (!e.isJsonPrimitive()) throw new JsonParseException("ByteArrayTag json value must be a json array values must all be numbers!");
+            final JsonPrimitive p = e.getAsJsonPrimitive();
+            if (!p.isNumber()) throw new JsonParseException("ByteArrayTag json value must be a json array values must all be numbers!");
+            bytes[i] = p.getAsByte();
+        }
+        setValue(bytes);
+    }
+
+    @Override
+    @NotNull
+    public JsonElement toJson() {
+        final byte[] bytes = getValue();
+        final JsonArray array = new JsonArray(bytes.length);
+        for (int i = 0; i < bytes.length; i++) {
+            array.add(bytes[i]);
+        }
+        return array;
+    }
+
     @Override
     void read(@NotNull DataInput dis)
         throws IOException
@@ -38,7 +68,7 @@ public class ByteArrayTag extends Tag<byte @NotNull []>
     @Override
     public byte getId()
     {
-        return TAG_BYTE_ARRAY;
+        return TagID.TAG_BYTE_ARRAY.getId();
     }
 
     @Override
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/ByteTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/ByteTag.java
index 1e7c306af..de6b1d810 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/ByteTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/ByteTag.java
@@ -1,5 +1,8 @@
 package com.mojang.nbt.tags;
 
+import com.google.gson.JsonElement;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonPrimitive;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
@@ -34,7 +37,7 @@ public class ByteTag extends Tag<@NotNull Byte>
     @Override
     public byte getId()
     {
-        return TAG_BYTE;
+        return TagID.TAG_BYTE.getId();
     }
 
     @Override
@@ -42,4 +45,19 @@ public class ByteTag extends Tag<@NotNull Byte>
     {
         return "\"" + getTagName() + "\": " + getValue();
     }
+
+    @Override
+    public void fromJson(@NotNull final JsonElement json) throws JsonParseException {
+        if (!json.isJsonPrimitive()) {
+            throw new JsonParseException("Json element '" + json + "' is not a valid byteTag!");
+        }
+        final JsonPrimitive primitive = json.getAsJsonPrimitive();
+        if (!primitive.isNumber()) throw new JsonParseException("Json element '" + json + "' is not a number!");
+        setValue(primitive.getAsByte());
+    }
+
+    @Override
+    public @NotNull JsonElement toJson() {
+        return new JsonPrimitive(getValue());
+    }
 }
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/CompoundTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/CompoundTag.java
index 8a6d7938e..11008e673 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/CompoundTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/CompoundTag.java
@@ -1,5 +1,8 @@
 package com.mojang.nbt.tags;
 
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
@@ -39,6 +42,26 @@ public class CompoundTag extends Tag<@NotNull Map<String, Tag<?>>>
         dos.writeByte(0);
     }
 
+    @Override
+    public void fromJson(@NotNull JsonElement element) throws JsonParseException {
+        if (!element.isJsonObject()) throw new JsonParseException("CompoundTag element must be a JsonObject!");
+        final JsonObject object = element.getAsJsonObject();
+        getValue().clear();
+        for (final Map.Entry<String, JsonElement> entry : object.entrySet()) {
+            put(entry.getKey(), Tag.deserializeFromJson(entry.getValue()));
+        }
+    }
+
+    @Override
+    @NotNull
+    public JsonElement toJson() {
+        final JsonObject out = new JsonObject();
+        for (final Map.Entry<String, Tag<?>> entry : getValue().entrySet()) {
+            out.add(entry.getKey(), Tag.serializeToJson(entry.getValue()));
+        }
+        return out;
+    }
+
 
     @Override
     public void read(@NotNull DataInput dis)
@@ -66,7 +89,7 @@ public class CompoundTag extends Tag<@NotNull Map<String, Tag<?>>>
     @Override
     public byte getId()
     {
-        return TAG_COMPOUND;
+        return TagID.TAG_COMPOUND.getId();
     }
 
     public Tag<?> getTagOrDefault(final String key, Tag<?> defaultTag)
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/DoubleArrayTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/DoubleArrayTag.java
index afc2b2f3c..a54dabaac 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/DoubleArrayTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/DoubleArrayTag.java
@@ -1,5 +1,9 @@
 package com.mojang.nbt.tags;
 
+import com.google.gson.JsonArray;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonPrimitive;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
@@ -30,6 +34,28 @@ public class DoubleArrayTag extends Tag<double @NotNull []>
         dos.write(bytes);
     }
 
+    @Override
+    public void fromJson(@NotNull final JsonElement element) throws JsonParseException {
+        if (!element.isJsonArray()) throw new JsonParseException("DoubleArrayTag json value must be a json array!");
+        final JsonArray array = element.getAsJsonArray();
+        final double[] doubles = new double[array.size()];
+        for (int i = 0; i < doubles.length; i++) {
+            doubles[i] = array.get(i).getAsDouble();
+        }
+        setValue(doubles);
+    }
+
+    @Override
+    @NotNull
+    public JsonElement toJson() {
+        final double[] doubles = getValue();
+        final JsonArray array = new JsonArray(doubles.length);
+        for (int i = 0; i < doubles.length; i++) {
+            array.add(doubles[i]);
+        }
+        return array;
+    }
+
     @Override
     void read(@NotNull DataInput dis)
         throws IOException
@@ -44,7 +70,7 @@ public class DoubleArrayTag extends Tag<double @NotNull []>
     @Override
     public byte getId()
     {
-        return TAG_DOUBLE_ARRAY;
+        return TagID.TAG_DOUBLE_ARRAY.getId();
     }
 
     @Override
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/DoubleTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/DoubleTag.java
index 890c87c3d..c29321a22 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/DoubleTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/DoubleTag.java
@@ -1,5 +1,8 @@
 package com.mojang.nbt.tags;
 
+import com.google.gson.JsonElement;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonPrimitive;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
@@ -24,6 +27,19 @@ public class DoubleTag extends Tag<@NotNull Double>
         dos.writeDouble(getValue());
     }
 
+    @Override
+    public void fromJson(@NotNull final JsonElement json) throws JsonParseException {
+        if (!json.isJsonPrimitive()) {
+            throw new JsonParseException("Json element '" + json + "' is not a valid doubleTag!");
+        }
+        setValue(json.getAsDouble());
+    }
+
+    @Override
+    public @NotNull JsonElement toJson() {
+        return new JsonPrimitive(getValue());
+    }
+
     @Override
     void read(@NotNull DataInput dis)
         throws IOException
@@ -34,7 +50,7 @@ public class DoubleTag extends Tag<@NotNull Double>
     @Override
     public byte getId()
     {
-        return TAG_DOUBLE;
+        return TagID.TAG_DOUBLE.getId();
     }
 
     @Override
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/EndTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/EndTag.java
index c83e0a9ee..2a5ba8ab5 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/EndTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/EndTag.java
@@ -1,5 +1,8 @@
 package com.mojang.nbt.tags;
 
+import com.google.gson.JsonElement;
+import com.google.gson.JsonNull;
+import com.google.gson.JsonParseException;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
@@ -23,10 +26,21 @@ public class EndTag extends Tag<Void>
     {
     }
 
+    @Override
+    public void fromJson(@NotNull JsonElement element) throws JsonParseException {
+
+    }
+
+    @Override
+    @NotNull
+    public JsonElement toJson() {
+        return JsonNull.INSTANCE;
+    }
+
     @Override
     public byte getId()
     {
-        return TAG_END;
+        return TagID.TAG_END.getId();
     }
 
     @Override
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/FloatTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/FloatTag.java
index 8266f004a..098f57e94 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/FloatTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/FloatTag.java
@@ -1,5 +1,8 @@
 package com.mojang.nbt.tags;
 
+import com.google.gson.JsonElement;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonPrimitive;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
@@ -34,7 +37,20 @@ public class FloatTag extends Tag<@NotNull Float>
     @Override
     public byte getId()
     {
-        return TAG_FLOAT;
+        return TagID.TAG_FLOAT.getId();
+    }
+
+    @Override
+    public void fromJson(@NotNull final JsonElement json) throws JsonParseException {
+        if (!json.isJsonPrimitive()) {
+            throw new JsonParseException("Json element '" + json + "' is not a valid floatTag!");
+        }
+        setValue(json.getAsFloat());
+    }
+
+    @Override
+    public @NotNull JsonElement toJson() {
+        return new JsonPrimitive(getValue());
     }
 
     @Override
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/IntTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/IntTag.java
index 03c94a1b6..365e73e34 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/IntTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/IntTag.java
@@ -1,5 +1,8 @@
 package com.mojang.nbt.tags;
 
+import com.google.gson.JsonElement;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonPrimitive;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
@@ -34,7 +37,22 @@ public class IntTag extends Tag<@NotNull Integer>
     @Override
     public byte getId()
     {
-        return TAG_INT;
+        return TagID.TAG_INT.getId();
+    }
+
+    @Override
+    public void fromJson(@NotNull final JsonElement json) throws JsonParseException {
+        if (!json.isJsonPrimitive()) {
+            throw new JsonParseException("Json element '" + json + "' is not a valid intTag!");
+        }
+        final JsonPrimitive primitive = json.getAsJsonPrimitive();
+        if (!primitive.isNumber()) throw new JsonParseException("Json element '" + json + "' is not a number!");
+        setValue(primitive.getAsInt());
+    }
+
+    @Override
+    public @NotNull JsonElement toJson() {
+        return new JsonPrimitive(getValue());
     }
 
     @Override
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/ListTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/ListTag.java
index b769ac4aa..b5d84173b 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/ListTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/ListTag.java
@@ -1,5 +1,9 @@
 package com.mojang.nbt.tags;
 
+import com.google.gson.JsonArray;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
 import com.mojang.nbt.UnknownTagException;
 import org.jetbrains.annotations.NotNull;
 
@@ -44,6 +48,36 @@ public class ListTag
 
     }
 
+    @Override
+    public void fromJson(@NotNull final JsonElement element) throws JsonParseException {
+        if (!element.isJsonObject()) throw new JsonParseException("ListTag JsonElement must be a json object!");
+        final JsonObject asObject = element.getAsJsonObject();
+        if (!asObject.has("type")) throw new JsonParseException("ListTag must have a defined type!");
+        final TagID type = TagID.fromIdString(asObject.get("type").getAsString());
+        getValue().clear();
+        if (asObject.has("list")) {
+            final JsonArray list = asObject.getAsJsonArray("list");
+            for (final JsonElement e : list) {
+                final Tag<?> entry = type.getNewTag();
+                entry.fromJson(e);
+                addTag(entry);
+            }
+        }
+    }
+
+    @Override
+    @NotNull
+    public JsonElement toJson() {
+        final JsonObject output = new JsonObject();
+        output.addProperty("type", TagID.fromId(tagType).getIdString());
+        final JsonArray list = new JsonArray(getValue().size());
+        for (final Tag<?> tag : getValue()) {
+            list.add(tag.toJson());
+        }
+        output.add("list", list);
+        return output;
+    }
+
     @Override
     void read(@NotNull DataInput dis)
         throws IOException
@@ -56,7 +90,7 @@ public class ListTag
         for(int i = 0; i < length; i++)
         {
             try {
-                Tag<?> tag = newTag(tagType);
+                Tag<?> tag = TagID.fromId(tagType).getNewTag();
                 tag.read(dis);
                 getValue().add(tag);
             } catch (IllegalArgumentException illegalArgumentException) {
@@ -68,7 +102,7 @@ public class ListTag
     @Override
     public byte getId()
     {
-        return TAG_LIST;
+        return TagID.TAG_LIST.getId();
     }
 
     @Override
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/LongArrayTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/LongArrayTag.java
index 8170d973b..6c55902bd 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/LongArrayTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/LongArrayTag.java
@@ -1,5 +1,9 @@
 package com.mojang.nbt.tags;
 
+import com.google.gson.JsonArray;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonPrimitive;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.DataInput;
@@ -43,7 +47,33 @@ public class LongArrayTag extends Tag<long @NotNull []>{
 
     @Override
     public byte getId() {
-        return TAG_LONG_ARRAY;
+        return TagID.TAG_LONG_ARRAY.getId();
+    }
+
+    @Override
+    public void fromJson(@NotNull final JsonElement element) throws JsonParseException {
+        if (!element.isJsonArray()) throw new JsonParseException("LongArrayTag json value must be a json array!");
+        final JsonArray array = element.getAsJsonArray();
+        final long[] longs = new long[array.size()];
+        for (int i = 0; i < longs.length; i++) {
+            final JsonElement e = array.get(i);
+            if (!e.isJsonPrimitive()) throw new JsonParseException("LongArrayTag json value must be a json array values must all be numbers!");
+            final JsonPrimitive p = e.getAsJsonPrimitive();
+            if (!p.isNumber()) throw new JsonParseException("LongArrayTag json value must be a json array values must all be numbers!");
+            longs[i] = p.getAsLong();
+        }
+        setValue(longs);
+    }
+
+    @Override
+    @NotNull
+    public JsonElement toJson() {
+        final long[] longs = getValue();
+        final JsonArray array = new JsonArray(longs.length);
+        for (int i = 0; i < longs.length; i++) {
+            array.add(longs[i]);
+        }
+        return array;
     }
 
     @Override
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/LongTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/LongTag.java
index 2dd4bc1f7..d7c9f61a2 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/LongTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/LongTag.java
@@ -1,5 +1,8 @@
 package com.mojang.nbt.tags;
 
+import com.google.gson.JsonElement;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonPrimitive;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
@@ -34,7 +37,22 @@ public class LongTag extends Tag<@NotNull Long>
     @Override
     public byte getId()
     {
-        return TAG_LONG;
+        return TagID.TAG_LONG.getId();
+    }
+
+    @Override
+    public void fromJson(@NotNull final JsonElement json) throws JsonParseException {
+        if (!json.isJsonPrimitive()) {
+            throw new JsonParseException("Json element '" + json + "' is not a valid longTag!");
+        }
+        final JsonPrimitive primitive = json.getAsJsonPrimitive();
+        if (!primitive.isNumber()) throw new JsonParseException("Json element '" + json + "' is not a number!");
+        setValue(primitive.getAsLong());
+    }
+
+    @Override
+    public @NotNull JsonElement toJson() {
+        return new JsonPrimitive(getValue());
     }
 
     @Override
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/ShortArrayTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/ShortArrayTag.java
index fb202da64..e61702166 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/ShortArrayTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/ShortArrayTag.java
@@ -1,5 +1,9 @@
 package com.mojang.nbt.tags;
 
+import com.google.gson.JsonArray;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonPrimitive;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
@@ -45,7 +49,33 @@ public class ShortArrayTag extends Tag<short @NotNull []>
     @Override
     public byte getId()
     {
-        return TAG_SHORT_ARRAY;
+        return TagID.TAG_SHORT_ARRAY.getId();
+    }
+
+    @Override
+    public void fromJson(@NotNull final JsonElement element) throws JsonParseException {
+        if (!element.isJsonArray()) throw new JsonParseException("ShortArrayTag json value must be a json array!");
+        final JsonArray array = element.getAsJsonArray();
+        final short[] shorts = new short[array.size()];
+        for (int i = 0; i < shorts.length; i++) {
+            final JsonElement e = array.get(i);
+            if (!e.isJsonPrimitive()) throw new JsonParseException("ShortArrayTag json value must be a json array values must all be numbers!");
+            final JsonPrimitive p = e.getAsJsonPrimitive();
+            if (!p.isNumber()) throw new JsonParseException("ShortArrayTag json value must be a json array values must all be numbers!");
+            shorts[i] = p.getAsShort();
+        }
+        setValue(shorts);
+    }
+
+    @Override
+    @NotNull
+    public JsonElement toJson() {
+        final short[] shorts = getValue();
+        final JsonArray array = new JsonArray(shorts.length);
+        for (int i = 0; i < shorts.length; i++) {
+            array.add(shorts[i]);
+        }
+        return array;
     }
 
     @Override
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/ShortTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/ShortTag.java
index 6a1d17782..bf50c6545 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/ShortTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/ShortTag.java
@@ -1,5 +1,8 @@
 package com.mojang.nbt.tags;
 
+import com.google.gson.JsonElement;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonPrimitive;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
@@ -34,7 +37,22 @@ public class ShortTag extends Tag<@NotNull Short>
     @Override
     public byte getId()
     {
-        return TAG_SHORT;
+        return TagID.TAG_SHORT.getId();
+    }
+
+    @Override
+    public void fromJson(@NotNull final JsonElement json) throws JsonParseException {
+        if (!json.isJsonPrimitive()) {
+            throw new JsonParseException("Json element '" + json + "' is not a valid shortTag!");
+        }
+        final JsonPrimitive primitive = json.getAsJsonPrimitive();
+        if (!primitive.isNumber()) throw new JsonParseException("Json element '" + json + "' is not a number!");
+        setValue(primitive.getAsShort());
+    }
+
+    @Override
+    public @NotNull JsonElement toJson() {
+        return new JsonPrimitive(getValue());
     }
 
     @Override
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/StringTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/StringTag.java
index 2972ac776..05fd29499 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/StringTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/StringTag.java
@@ -1,5 +1,8 @@
 package com.mojang.nbt.tags;
 
+import com.google.gson.JsonElement;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonPrimitive;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
@@ -34,7 +37,22 @@ public class StringTag extends Tag<@NotNull String>
     @Override
     public byte getId()
     {
-        return TAG_STRING;
+        return TagID.TAG_STRING.getId();
+    }
+
+    @Override
+    public void fromJson(@NotNull final JsonElement json) throws JsonParseException {
+        if (!json.isJsonPrimitive()) {
+            throw new JsonParseException("Json element '" + json + "' is not a valid stringTag!");
+        }
+        final JsonPrimitive primitive = json.getAsJsonPrimitive();
+        if (!primitive.isString()) throw new JsonParseException("Json element '" + json + "' is not a string!");
+        setValue(primitive.getAsString());
+    }
+
+    @Override
+    public @NotNull JsonElement toJson() {
+        return new JsonPrimitive(getValue());
     }
 
     @Override
